﻿using System;

using HylaFAX;

namespace faxclient
{
    class Program
    {
        static void Main(string[] args)
        {
            string hostname = "10.0.12.161";
            string username = "dev";
            string password = "testing";

            int jobid = SimpleJob(hostname, username, password, @"C:\Temp\testfax.pdf", "12125558774", "david@example.com");
            Console.WriteLine("Job ID: " + jobid);

            int jobid2 = VerboseJob(hostname, username, password, @"C:\Temp\ninepage.tif", "12125558770", "david@example.com");
            Console.WriteLine("Job ID: " + jobid2);

            Console.ReadLine();
        }

        /**
         * 
         * 
         */
        static int SimpleJob(string hostname, string username, string password, string faxdocument, string faxnumber, string email)
        {
            HylaFAXClient client = new HylaFAXClient(hostname, username, password);
            return client.createJob(new HylaFAXJobOptions(faxdocument, faxnumber, email));
        }

        /**
         * 
         * 
         */
        static int VerboseJob(string hostname, string username, string password, string faxdocument, string faxnumber, string email)
        {
            HylaFAXClient client = new HylaFAXClient(hostname, username, password);
            client.setVerbose(true);  // Output to the console all data sent and received on the hylafax port
            client.setPort(4559);

            Console.WriteLine("client: Connecting to " + hostname);
            switch (client.connect())
            {
                case ConnectionStatus.FailedToConnect:
                    Console.WriteLine("Failed to connect to host");
                    return 0;
                case ConnectionStatus.FailedToAuthenticate:
                    Console.WriteLine("Failed to authenticate");
                    return 0;
            }

            Console.WriteLine("client: Submitting job");

            HylaFAXJobOptions options = new HylaFAXJobOptions(faxdocument, faxnumber, email);
            options.jobtag = "Testing";
            options.jobpriority = "200";
            options.maxdials = "1";
            //options.modemgroup = "debug";  // NOTE: /var/spool/hylafax/etc/config must contain:   ModemGroup: "debug:boston"
            options.notify = "none";
            options.fromuser = "developer";
            options.coverpage = @"C:\Temp\testfax.pdf";

            int jobid = client.createJob(options);

            client.quit();
            return jobid;
        }
    }
}
